//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "phonebook.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "VirtualTrees"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::VirtualStringTree1GetNodeDataSize(
      TBaseVirtualTree *Sender, int &NodeDataSize)
{
    NodeDataSize = sizeof(structPhonebook);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::VirtualStringTree1GetText(TBaseVirtualTree *Sender,
      PVirtualNode Node, TColumnIndex Column, TVSTTextType TextType,
      WideString &CellText)
{
    if (!Node)
        return;

    structPhonebook *pPhonebook = (structPhonebook *)Sender->GetNodeData(Node);

    CellText = pPhonebook->Colunms[Column].Value;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
    PVirtualNode Node;
    structPhonebook *pPhonebook;

    Node = VirtualStringTree1->AddChild(NULL);
    if (Node)
    {
        pPhonebook = (structPhonebook *)VirtualStringTree1->GetNodeData(Node);
        pPhonebook->Colunms[0].Value = "";
        pPhonebook->Colunms[0].PropertyTyp = ptEdit;
        pPhonebook->Colunms[0].Changed = false;

        pPhonebook->Colunms[1].Value = "02-1234-5678";
        pPhonebook->Colunms[1].PropertyTyp = ptEdit;
        pPhonebook->Colunms[1].Changed = false;

        pPhonebook->Colunms[2].Value = "";
        pPhonebook->Colunms[2].PropertyTyp = ptCombo;
        pPhonebook->Colunms[2].Changed = false;

        pPhonebook->Colunms[3].Value = "1970-3-2";
        pPhonebook->Colunms[3].PropertyTyp = ptDate;
        pPhonebook->Colunms[3].Changed = false;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::VirtualStringTree1CreateEditor(
      TBaseVirtualTree *Sender, PVirtualNode Node, TColumnIndex Column,
      IVTEditLink *EditLink)
{
    if (!Node) return;

    TPropertyEditLink* PropertyLink;
    structPhonebook *pPhonebook = (structPhonebook *)Sender->GetNodeData(Node);

    if (pPhonebook)
    {
        if (Column == 2)
        {

            TStringList* MyList = new TStringList();
            try
            {
              MyList->Add("");
              MyList->Add("");

              PropertyLink = new TPropertyEditLink((TVirtualStringTree*)Sender, Node, Column, &(pPhonebook->Colunms[Column]), MyList);
            }
            __finally
            {
              delete MyList;

            }

        }
        else
            PropertyLink = new TPropertyEditLink((TVirtualStringTree*)Sender, Node, Column, &(pPhonebook->Colunms[Column]));
        PropertyLink->QueryInterface(__uuidof(IVTEditLink), (void**)EditLink);
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::VirtualStringTree1Editing(TBaseVirtualTree *Sender,
      PVirtualNode Node, TColumnIndex Column, bool &Allowed)
{
    Allowed = false;
    if (!Node) return;                                                //  only for safety the program !
    structPhonebook * pPhonebook = (structPhonebook *)Sender->GetNodeData(Node);
    if (pPhonebook)
        Allowed = (pPhonebook->Colunms[Column].PropertyTyp != ptNone);
}
//---------------------------------------------------------------------------

